for index, hook in pairs({"join", "clientdata", "serveraction", "menu", "always", "attack"}) do
	addhook(hook, "editor.hook." .. hook)
end

function editor.hook.join(id)
	editor.resetplayerdata(id)
end

function editor.hook.clientdata(id, mode, data1, data2)
	editor.data.player[id].clientdata[mode] = {data1, data2}
end

function editor.hook.serveraction(id, action)
	if (action == 1) then
		if (player(id, "health") > 0) then
			if (editor.data.player[id].draw.mode == 0) then
				editor.mainmenu(id)
			elseif (editor.data.player[id].draw.mode ~= 3 and editor.data.player[id].draw.mode ~= 6 and editor.data.player[id].draw.mode ~= 7) then
				editor.optionsmenu(id)
			end
		end
	end
end

function editor.hook.menu(id, title, button)
	if (editor.data.menu[title]) then
		if (button == 0) then
			editor.data.player[id].menu.button = button
			
			if (title ~= "Map Tile Editor") then
				editor.mainmenu(id)
			end
		end
		
		if (editor.data.menu[title].pages == 1) then
			editor.data.player[id].menu.button = button
		else
			if (button == 8) then
				editor.data.player[id].menu.page = editor.data.player[id].menu.page - 1
				
				editor.menu(id, title)
			elseif (button == 9) then
				editor.data.player[id].menu.page = editor.data.player[id].menu.page + 1
				
				editor.menu(id, title)
			elseif (button ~= 0) then
				editor.data.player[id].menu.button = button + (6 * (editor.data.player[id].menu.page - 1))
			end
		end
	end
	
	if (title == "Map Tile Editor") then
		if (editor.data.player[id].menu.button ~= 0) then
			if (editor.data.player[id].menu.button < 3) then
				editor.data.player[id].draw.mode = editor.data.player[id].menu.button
			else
				editor.data.player[id].draw.mode = editor.data.player[id].menu.button + 1
			end
			
			if (editor.data.player[id].menu.button <= 4) then
				local buttonname = {"Draw Tile by Tile", "Draw Area of Tiles", "Fill Area with Tiles", "Replace"}
				
				editor.tilemenu(id, buttonname[editor.data.player[id].menu.button])
			else
				editor.data.player[id].draw.mode = 6
				editor.data.player[id].drawing = true
			end
		end
	elseif (title == "Draw Tile by Tile" or title == "Draw Area of Tiles" or title == "Fill Area with Tiles" or title == "Replace" or title == "With") then
		if (editor.data.menu[title].pages == 1 or (editor.data.menu[title].pages > 1 and (button ~= 8 and button ~= 9))) then
			freeimage(editor.data.player[id].image.tileset)
			
			editor.data.player[id].image.tileset = nil
			
			if (editor.data.player[id].menu.button ~= 0) then
				if (title ~= "With") then
					editor.data.player[id].draw.frame[1] = editor.data.player[id].menu.button - 1
					
					if (title == "Replace") then
						editor.tilemenu(id, "With")
					else
						editor.data.player[id].drawing = true
					end
				else
					editor.data.player[id].draw.frame[2] = editor.data.player[id].menu.button - 1
					editor.data.player[id].draw.mode = 5
					
					editor.settile(id)
				end
			end
		end
	elseif (title == "Options") then
		if (editor.data.player[id].menu.button == 0) then
			editor.removehistory(id, "undo", true)
			editor.removehistory(id, "redo", true)
			
			editor.data.player[id].draw.mode = 0
			editor.data.player[id].drawing = false
			
			editor.removeblock(id)
			editor.mainmenu(id)
		end
		
		if (editor.data.player[id].draw.mode <= 4) then
			if (editor.data.player[id].menu.button == 1) then
				editor.removehistory(id, "undo", true)
				editor.removehistory(id, "redo", true)
				
				editor.data.player[id].drawing = false
				local buttonname = {"Draw Tile by Tile", "Draw Area of Tiles", "", "Fill Area with Tiles"}
				
				editor.tilemenu(id, buttonname[editor.data.player[id].draw.mode])
			elseif (editor.data.player[id].menu.button == 2) then
				editor.resetmap()
				editor.removehistory(id, "undo", true)
				editor.removehistory(id, "redo", true)
			elseif (editor.data.player[id].menu.button == 4 or editor.data.player[id].menu.button == 5) then
				editor.sethistory(id, editor.data.player[id].menu.button == 4 and "undo" or "redo")
				editor.optionsmenu(id)
			end
		elseif (editor.data.player[id].draw.mode == 8) then
			if (editor.data.player[id].menu.button == 1) then
				editor.data.player[id].draw.mode = 6
			elseif (editor.data.player[id].menu.button == 2) then
				editor.resetmap()
				editor.removehistory(id, "undo", true)
				editor.removehistory(id, "redo", true)
			elseif (editor.data.player[id].menu.button == 4 or editor.data.player[id].menu.button == 5) then
				editor.sethistory(id, editor.data.player[id].menu.button == 4 and "undo" or "redo")
				editor.optionsmenu(id)
			end
		else
			if (editor.data.player[id].menu.button == 1) then
				editor.resetmap()
				editor.removehistory(id, "undo", true)
				editor.removehistory(id, "redo", true)
			elseif (editor.data.player[id].menu.button == 3 or editor.data.player[id].menu.button == 4) then
				editor.sethistory(id, editor.data.player[id].menu.button == 3 and "undo" or "redo")
				editor.optionsmenu(id)
			end
		end
	end
end

function editor.hook.always()
	for index, id in pairs(player(0, "tableliving")) do
		if (editor.data.player[id].drawing) then
			editor.drawblock(id)
		end
	end
end

function editor.hook.attack(id)
	if (editor.data.player[id].draw.mode > 0) then
		if (editor.data.player[id].draw.mode ~= 2 and editor.data.player[id].draw.mode ~= 6 and editor.data.player[id].draw.mode ~= 7) then
			editor.newhistory(id, "undo")
		end
		
		editor.settile(id)
	end
end